﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LongtextDisplay
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            DataColumn dc1 = new DataColumn("ID");
            DataColumn dc2 = new DataColumn("LongValue");
            dt.Columns.Add(dc1);
            dt.Columns.Add(dc2);
            for (int r = 1; r <= 10;r++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = r;
                if(r%2 == 0)
                {
                    dr[1] = "123,456,123,456.2355";
                }
                else
                {
                    dr[1] = 1234.56;
                }
                dt.Rows.Add(dr);
            }
            c1TrueDBGrid1.DataSource = dt;
            c1TrueDBGrid1.Splits[0].DisplayColumns[1].AllowSizing = false;
            c1TrueDBGrid1.Splits[0].DisplayColumns[1].OwnerDraw = true;
            c1TrueDBGrid1.OwnerDrawCell += new C1.Win.C1TrueDBGrid.OwnerDrawCellEventHandler(c1TrueDBGrid1_OwnerDrawCell);
         }

       void c1TrueDBGrid1_OwnerDrawCell(object sender, C1.Win.C1TrueDBGrid.OwnerDrawCellEventArgs e)
        {
            e.Handled = true;
            e.Graphics.FillRectangle(new SolidBrush(e.Style.BackColor), e.CellRect);
            object val = c1TrueDBGrid1.Columns[e.Col].CellValue(e.Row);
            SizeF size = e.Graphics.MeasureString(val.ToString(), c1TrueDBGrid1.Splits[0].DisplayColumns[e.Col].Style.Font);
            int width = (int)Math.Ceiling(size.Width);
            int cellwidth = e.CellRect.Width;
            if (width > cellwidth)
             {
               int r = 1;
               string s = e.Text;
               string ns = "";
               while (width > cellwidth - 5)
               {
                  ns = s.Substring(0, s.Length - r);
                  size = e.Graphics.MeasureString(ns.ToString(), c1TrueDBGrid1.Splits[0].DisplayColumns[e.Col].Style.Font);
                  width = (int)Math.Ceiling(size.Width);
                  r++;
                  s = ns;
                }
                ns = ns + "....";
                e.Graphics.DrawString(ns, e.Style.Font, new SolidBrush(Color.Black), new PointF(e.CellRect.X, e.CellRect.Y));
              }
              else
              {
                e.Graphics.DrawString(e.Text, e.Style.Font, new SolidBrush(Color.Black), new PointF(e.CellRect.X, e.CellRect.Y));
              }
          }
    }
}
